var ImageLazyLoading = {
    imageArray : [],
    loadingCount : 0,
    imageLoading : function($timeout) {
        if (ImageLazyLoading.loadingCount > 3) {
            return;
        }
        ImageLazyLoading.loadingCount++;
        var Loader = ImageLazyLoading.imageArray.shift();
        if (Loader) {
            var image = new window.Image();
            image.src = Loader.imageLoader;
            image.onload = function () {
                Loader.element.addClass('img_view_no_animate');
                $timeout(function() {
                    Loader.element.attr('src', image.src);
                    Loader.element.addClass('img_view_animate');
                }, 100);

                ImageLazyLoading.loadingCount--;
                if (ImageLazyLoading.imageArray.length===0){
                    ImageLazyLoading.loadingCount = 0;
                }
                ImageLazyLoading.imageLoading($timeout);
            };

            image.onerror = function () {
                if (Loader.element.attr('error_image') && !Loader.element.attr('src')) {
                    Loader.element.addClass('img_view_no_animate');
                    $timeout(function () {
                        Loader.element.attr('src', Loader.element.attr('error_image'));
                        Loader.element.addClass('img_view_animate');
                    }, 100);
                }

                ImageLazyLoading.loadingCount--;
                if (ImageLazyLoading.imageArray.length===0){
                    ImageLazyLoading.loadingCount = 0;
                }
                ImageLazyLoading.imageLoading($timeout);
            };

        } else {
            ImageLazyLoading.loadingCount--;
            if (ImageLazyLoading.imageArray.length===0){
                ImageLazyLoading.loadingCount = 0;
            }
        }
    }
};

angular.module('LoanApplication.directives', [])

    .directive('imageLoader', function ($timeout) {
        return function (scope, element, attrs) {
            attrs.$observe('imageLoader', function (newValue) {
                if(!newValue) {
                    return;
                }

                ImageLazyLoading.imageArray.push({'element': element, 'imageLoader': newValue});
                ImageLazyLoading.imageLoading($timeout);
            });
        };
    })

    .directive('focus', function () {
        return function (scope, element, attrs) {
            attrs.$observe('focus', function (newValue) {
                if (newValue && newValue.trim()!=='' && (newValue && newValue==='true')){
                    element[0].focus();
                }
            });
        };
    })

    .filter('percentage', function ($window) {
        return function (input, decimals, suffix) {
            decimals = angular.isNumber(decimals)? decimals :  3;
            // suffix = suffix || '%';
            if ($window.isNaN(input)) {
                return '';
            }
            input = '' + input;
            input += (input.indexOf('.')>-1?'':'.')+'0000000000000';
            return  input.substr(0, input.indexOf('.')+decimals+1)+ suffix;
        };
    })

    .directive("long", function ($timeout) {
        return {
            require:"ngModel",
            link:function(scope, element, attrs, ngModel) {
                ngModel.$parsers.push(function (viewValue) {
                    if (!viewValue){return undefined;}
                    if (!/^[0-9]+$/igm.test(viewValue)){
                        viewValue = viewValue.toString().replace(/[^0-9]+/igm, '');
                        $timeout(function () {
                            element.val(viewValue);
                        }, 200);
                    }
                    return viewValue;
                });
            }
        };
    })

;
