angular.module('LoanApplication.services', [])

    .factory("productService", function($http, $cacheFactory, config) {
        var service = {
            productCache: $cacheFactory("product"),
            getProductById : function(product_id, callback) {
                if (service.productCache.get(product_id)){return callback(service.productCache.get(product_id));}

                var params = {};
                params.id = product_id;
                params.app_product_key = config.app_product_key;

                $http({
                    timeout: 10000,
                    method: 'jsonp',
                    url: config.data_domain + "/index.php/product/?callback=JSON_CALLBACK",
                    params: params
                })
                .success(function (response) {
                    if (!response.success || !response.data || !response.data) {
                        return;
                    }
                    service.productCache.put(product_id, response.data);
                })
                .finally(function() {
                    if (callback){callback(service.productCache.get(product_id));}
                })
                ;
            }
        };

        return service;
    })

;